/*
_________________________________________________________________________________________________________________________

    SDLengine core of sdlBasic



    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Library General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Library General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    __vroby__
    __vroby__@libero.it

_________________________________________________________________________________________________________________________

*/

#include "SDLengine.h"

//_________________________________________________________________________________________________________________________

// KEYBOARD
//_________________________________________________________________________________________________________________________

//key(keycode)								: return 1 if is press the key keycode
int key (int keycode)
{
	Uint8 *keystate;

	if (keycode<1 ||keycode>512){
	    error_description="SDLengine error - key: invalid keycode value ";
	    error_type=1;
	    SDLerr(stderr, "SDLengine error- key: %d is an invalid keycode value", keycode);
	    return -1;
	}
	if (autotimer()!=0)return -1;
	getevent();
	keystate = SDL_GetKeyState(NULL);
#if defined(ZIPIT_Z2)
	// If ALT key is down, compare to the last SDL unicode key event.
	if ((keystate[SDLK_LALT]) || (keystate[SDLK_RALT]) || (keystate[SDLK_MODE]))
	{
	  //return (keycode == lastkey);
	  // Handle the SDLK_F1 ... SDLK_F12 keys
	  if (keystate[SDLK_LSHIFT]) switch (keycode) {
	  case 282:
	    keycode = 'q';
	    break;
	  case 283:
	    keycode = 'w';
	    break;
	  case 284:
	    keycode = 'e';
	    break;
	  case 285:
	    keycode = 'r';
	    break;
	  case 286:
	    keycode = 't';
	    break;
	  case 287:
	    keycode = 'y';
	    break;
	  case 288:
	    keycode = 'u';
	    break;
	  case 289:
	    keycode = 'i';
	    break;
	  case 290:
	    keycode = 'o';
	    break;
	  case 291:
	    keycode = 'p';
	    break;
	  case 292:
	    keycode = 'a';
	    break;
	  case 293:
	    keycode = 's';
	    break;
	    }
	  else

	  switch (keycode) {
	  case '1':
	    keycode = 'q';
	    break;
	  case '2':
	    keycode = 'w';
	    break;
	  case '3':
	    keycode = 'e';
	    break;
	  case '4':
	    keycode = 'r';
	    break;
	  case '5':
	    keycode = 't';
	    break;
	  case '6':
	    keycode = 'y';
	    break;
	  case '7':
	    keycode = 'u';
	    break;
	  case '8':
	    keycode = 'i';
	    break;
	  case '9':
	    keycode = 'o';
	    break;
	  case '0':
	    keycode = 'p';
	    break;

	    // Probably don't really need the rest of these.
	    // Most are shift key combos on a normal kbd.
	    // It might be nice to add FN keys on ALT-Shift-number keys.
	  case '$':
	    keycode = 'a';
	    break;
	  case '#':
	    keycode = 's';
	    break;
	  case '&':
	    keycode = 'd';
	    break;
	  case '@':
	    keycode = 'f';
	    break;
	  case '"':
	    keycode = 'g';
	    break;
	  case '\'':
	    keycode = 'h';
	    break;
	  case '[':
	    keycode = 'j';
	    break;
	  case ']':
	    keycode = 'k';
	    break;
	  case '-':
	    keycode = 'l';
	    break;

	  case '!':
	    keycode = 'z';
	    break;
	  case '/':
	    keycode = 'x';
	    break;
	  case '+':
	    keycode = 'c';
	    break;
	  case '*':
	    keycode = 'v';
	    break;
	  case '=':
	    keycode = 'b';
	    break;
	  case '_':
	    keycode = 'n';
	    break;
	  case '?':
	    keycode = 'm';
	    break;
	  case ':':
	    keycode = ';';
	    break;


	  case '<':
	    keycode = ',';
	    break;
	  case '>':
	    keycode = '.';
	    break;
	  }
	}
#endif
	if (keystate[keycode])return 1;
	return 0;
}
//_______________________________________________________________________________________________________________________

//inkey									: return ascii code of key press
int inkey()
{
	if (autotimer()!=0)return -1;
	getevent();
	return lastkey;
}
//_______________________________________________________________________________________________________________________

//waitkey(keycode)							: wait a key pression (-1 =any key)
int waitkey(int keycode)
{
	if (keycode==0)
		while(inkey()==0){
		    if (autotimer()!=0)return -1;
		}
	else
		while(inkey()!=keycode){
		    if (autotimer()!=0)return -1;
		}
	return 0;
}
